#ifndef VECTOR_H
#define VECTOR_H

#include <stdlib.h>
#include <assert.h>

template <class T> class Vector
{
private:
   T *array;
   int _size, capacity;

public:
   Vector ()
   {
      _size = 0;
      capacity = 0;
      array = NULL;
   }

   ~Vector ()
   {
      free (array);
   }

   int size () { return _size; }

   void truncate (int n)
   {
      assert (n >= 0 && n <= _size);
      _size = n;
   }

   T* get (int i)
   {
      assert (i >= 0 && _size - i > 0);
      return array + i;
   }

   void set (int i, T t)
   {
      assert (i >= 0);
      if (i >= capacity) {
         capacity = i + 1;
         array = (T *) realloc (array, capacity * sizeof (T));
      }
      array[i] = t;
      _size = i + 1;
   }
};

#endif
