#ifndef WORKPOOL_H
#define WORKPOOL_H

#include <pthread.h>
#include "vector.H"

typedef void (*action_fn)(void *data);

struct Task;
struct Queue;

class WorkPool {
	private:
		pthread_mutex_t mutex;
		pthread_mutex_t condMutex;
		pthread_cond_t cond;
		Vector <Queue*> *queues;
		Vector <pthread_t> *threads;

		void signal();
		Task* getTask(Queue *q);
		Task* getTask();
		void run();
		static void *thread_main(void *data);

	public:
		WorkPool(int numThreads);
		~WorkPool();

		Queue *createQueue ();
		void addQueue (Queue *q);
		void removeQueues ();
		void addTask (Queue *q, action_fn action, void *data);
};

#endif
